<template>
  <div class="sellReturn pagePadding">
    <div v-if="powers.some((i) => i == '001')">
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @selection="handleSelection"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="3" style="width: 120px">
                <el-switch 
                  v-model="parmValue.use_type"
                  :active-value="usetypeOtions[1].value"
                  :inactive-value="usetypeOtions[0].value"
                  :active-text="usetypeOtions[1].label"
                  :inactive-text="usetypeOtions[0].label"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                />
              </el-col>

              <!-- 时间区间 -->
              <el-col :span="6" style="width: 303px; padding: 0 0 0 10px">
                <period-date-picker
                  :type="1"
                  :width="'135px'"
                  :size="searchSize"
                  :start="parmValue.start"
                  :end="parmValue.end"
                  @timeReturned="handleTime"
                />
              </el-col>
              <el-col :span="6" style="width: 240px; padding: 0 0 0 10px">
                <search-customer
                  :value="parmValue.customer_code"
                  :size="'mini'"
                  style="width: 100%"
                  :names="parmValue.customer_name"
                  :placeholder="'企业客户'"
                  :disabled="false"
                  :is-detail="true"
                  @searchChange="customerChange"
                />
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
            </el-row>

            <el-row style="padding: 10px 0 0 0">
              <el-col :span="4" style="width: 200px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.status"
                  filterable
                  clearable
                  placeholder="退货单状态"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in statusOptions"
                    :key="'status' + item.value"
                    :label="item.label"
                    :value="item.value"
                  />
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 151px; padding: 0 0 0 10px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.order_source"
                  filterable
                  clearable
                  placeholder="订单来源"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in xs_order_source_options"
                    :key="'orderstatus' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 151px; padding: 0 0 0 10px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.order_type"
                  filterable
                  clearable
                  placeholder="商品类型"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in xs_order_type_options"
                    :key="'orderstatus' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>

              <el-col :span="4" style="width: 240px; padding: 0 0 0 10px">
                <search-work-company
                  :value="parmValue.companyNo"
                  :placeholder="'业务公司'"
                  style="width: 100%"
                  :size="searchSize"
                  @searchChange="companyNosearchChange"
                />
              </el-col>
              <el-col :span="4" class="fr" style="width: 66px; padding: 0 0 0 10px">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
            </el-row>

            <el-row style="padding: 10px 0 0 0">
              <el-col :span="6" style="width: 502px">
                <el-input
                  clearable
                  placeholder="关键字"
                  v-model="s_input"
                  maxlength="40"
                  :size="searchSize"
                  class="input-with-select"
                >
                  <el-select
                    v-model="select"
                    style="width: 150px"
                    slot="prepend"
                    placeholder="关键字类型"
                  >
                    <el-option label="销售退货单编号" value="returnCode" />
                    <el-option label="销售订单编号" value="orderCode" />
                    <el-option label="申请人部门" value="company_name" />
                    <el-option label="商品成本编号" value="good_code" />
                    <el-option label="上线商品编号" value="skuCode" />
                    <el-option label="申请人" value="apply_name" />
                  </el-select>
                  <el-button
                    slot="append"
                    icon="el-icon-search"
                    @click="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  ></el-button>
                </el-input>
              </el-col>

              <!-- <el-col :span="4" >
                  <el-select style="width:100%;margin-left:10px;margin-top:10px" placeholder="供应商端" clearable size="mini"  v-model="parmValue.has_account"  
                    @change="
                        pageInfo.curr = 1;
                        parmValue.page = 1;
                        searchList();
                      "
                  >
                    <el-option value="0" label="未开通" />
                    <el-option value="1" label="已开通"/>
                  </el-select>
              </el-col> -->
              <div style="float: right" v-if="!isSupertube && powers.includes('087')">
                <el-button type="primary" size="mini" @click="handleExport"
                  >退货单导出</el-button
                >
              </div>
            </el-row>
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.value == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #use_type="{ scope }">
          <el-tag size="mini">
            {{
              (usetypeOtions.find(({ value }) => value === scope.row.use_type) || {})
                .label || "---"
            }}
          </el-tag>
        </template>
        <template #order_type="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (
                xs_order_type_options.find((item) => item.id == scope.row.order_type) ||
                {}
              ).label || '--'
            "
          ></el-tag>
        </template>
        <template #order_source="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (
                xs_order_source_options.find(
                  (item) => item.id == scope.row.order_source
                ) || {}
              ).label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="getRouter('supplierSellReturnDetail', scope.row.returnCode)"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import companyHelper from "@/mixins/companyHelper";
import columns from "./columns";
import asyncRequest from "@/apis/service/supplierSellOut/supplierSellReturn";
import { mapGetters } from "vuex";
import urlConfig from "@/apis/url-config";
import {
  xs_order_type_options,
  xs_order_source_options,
  usetypeOtions,
} from "@/assets/js/statusList";

export default {
  name: "sellReturn",
  mixins: [mixinPage, resToken, companyHelper],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size", "isSupertube"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "supplierSellReturn"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      xs_order_type_options,
      xs_order_source_options,
      usetypeOtions,
      fileUrl: urlConfig.baseURL,
      select: "returnCode", //默认选择下拉框
      s_input: "", //搜索框内容
      select_list: [],
      sitem: null,
      // 状态
      statusOptions: [
        { value: "1", label: "待业务审批" },
        { value: "8", label: "供应商已驳回,待采购审核" },
        { value: "9", label: "待供应商审核" },
        { value: "10", label: "业务公司修改,待供应商确认" },
        { value: "11", label: "待设置工单" },
        { value: "12", label: "待库管收货" },
        { value: "4", label: "退货完成" },
        { value: "5", label: "业务驳回" },
        { value: "13", label: "已取消申请" },
      ],
      loading: false,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        customer_name:"",
        customer_code:"",
        companyNo: "",
        returnCode: "", //销售退货code
        orderCode: "", //销售订单code
        company_name: "",
        good_code: "",
        skuCode: "",
        apply_name: "", //申请人
        start: "",
        end: "",
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
        order_type: "",
        use_type: "1",
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      const { page, size } = this.parmValue;
      // this.parmValue.start = start || last_start;
      // this.parmValue.end = end || last_end;
      // if(this.parmValue.companyNo.length>0){
      //     this.customerCode = [this.parmValue.companyNo] ;
      // }

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      this.s_input = this.parmValue.s_input;
    } else {
      this.select = "returnCode";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    async customerChange(e) {
      if (e && e.id) {
        this.parmValue.customer_code = [e.code];
        this.parmValue.customer_name = e.label;
        // this.parmValue.companyNo = e.code;
      } else {
        this.parmValue.customer_code = [];
        this.parmValue.customer_name = "";
        // this.parmValue.companyNo = "";
      }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    companyNosearchChange({ code }) {
      this.parmValue.companyNo = code;
      this.searchList();
    },
    handleExport() {
      if (this.select_list.length === 0) {
        this.$message.warning("请选择一条退货单");
        return;
      }

      this.parmValue.returnCode = this.select === "returnCode" ? this.s_input : "";
      this.parmValue.orderCode = this.select === "orderCode" ? this.s_input : "";
      this.parmValue.apply_name = this.select === "apply_name" ? this.s_input : "";
      this.parmValue.company_name = this.select === "company_name" ? this.s_input : "";
      this.parmValue.good_code = this.select === "good_code" ? this.s_input : "";
      this.parmValue.skuCode = this.select === "skuCode" ? this.s_input : "";
      let model = JSON.parse(JSON.stringify(this.parmValue));

      if (!this.loading) {
        this.loading = true;
        let httpType = `aplication/zip`;
        axios({
          method: "post",
          url: this.fileUrl + "/admin/reorderExport",
          responseType: "blob",
          data: {
            ...model,
            noRelation: true,
            supplierNo: this.currentCompany,
          },
          headers: {
            Accept: httpType,
          },
        })
          .then((res) => {
            if (res && res.status == 200 && res.data) {
              let url = window.URL.createObjectURL(
                new Blob([res.data], { type: httpType })
              );
              let link = document.createElement("a");
              link.style.display = "none";
              link.href = url;
              let excelName = "退货单.zip";
              link.setAttribute("download", excelName);
              document.body.appendChild(link);
              link.click();
              link.remove();
              window.URL.revokeObjectURL(url); //释放掉blob对象
              this.$message.success(`导出成功！`);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            } else {
              this.$message.error(res.data.message);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            }
          })
          .catch((error) => {
            console.log(error);
            this.loading = false;
          });
      }
    },
    handleSelection(order) {
      const { list } = order;
      this.select_list = list;
    },
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          // type: 'view',
        };

        //有多选框的条件
        this.parmValue.select = this.select;
        // this.parmValue.sselect = this.sselect ;
        this.parmValue.s_input = this.s_input;
        //
        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    restSearch() {
      this.s_input = ""; //清除输入框内容
      this.select = ""; //清除下拉框选中项
      this.parmValue = {
        order_type: "",
        company_name: "", //申请人部门
        good_code: "",
        returnCode: "", //销售退货code
        orderCode: "", //销售订单code
        apply_name: "", //申请人
        start: "",
        end: "",
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
        use_type: "1",
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;
      this.parmValue.returnCode = this.select === "returnCode" ? this.s_input : "";
      this.parmValue.orderCode = this.select === "orderCode" ? this.s_input : "";
      this.parmValue.apply_name = this.select === "apply_name" ? this.s_input : "";
      this.parmValue.company_name = this.select === "company_name" ? this.s_input : "";
      this.parmValue.good_code = this.select === "good_code" ? this.s_input : "";
      this.parmValue.skuCode = this.select === "skuCode" ? this.s_input : "";
      let model = JSON.parse(JSON.stringify(this.parmValue));

      const res = await asyncRequest.list({
        ...model,
        customer_code:Array.isArray(model.customer_code) ? model.customer_code[0] : model.customer_code,
        supplierNo: this.currentCompany,
        noRelation: true,
      });
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    //物流公司查询
    async handleCompany(e) {
      console.log(e, "要求传快递简称，不传id"); //
      if (e && e.code) {
        this.parmValue.postCompany = [e.shortName];
        this.parmValue.page = 1;
      }
      await this.searchList();
    },

    // 时间
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }
      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.sellReturn {
}
</style>
